import windows;

public:

alias wchar[] LPWSTR;
alias wchar[] LPCWSTR;

HRESULT MAKE_HRESULT(int sev, int fac, int code)
{
	return (HRESULT)((sev << 31) | (fac << 16) | code);
}

extern(Windows)
{
  DWORD GetModuleFileNameA(HMODULE hModule, LPSTR lpFilename, DWORD nSize);
  DWORD GetModuleFileNameW(HMODULE hModule, LPWSTR lpFilename, DWORD nSize);
  version(unicode)
  {
    DWORD GetModuleFileName(HMODULE hModule, LPWSTR lpFilename, DWORD nSize)
    {
      return GetModuleFileNameW(hModule,lpFilename,nSize);
    }
  }
  else
  {
    DWORD GetModuleFileName(HMODULE hModule, LPSTR lpFilename, DWORD nSize)
    {
      return GetModuleFileNameA(hModule,lpFilename,nSize);
    }
  }

  HMODULE GetModuleHandleA(LPCSTR lpModuleName);
  HMODULE GetModuleHandleW(LPCWSTR lpModuleName);
  version(unicode)
  {
    HMODULE GetModuleHandle(LPCWSTR lpModuleName)
    {
      return GetModuleHandleW(lpModuleName);
    }
  }
  else
  {
    HMODULE GetModuleHandle(LPCSTR lpModuleName)
    {
      return GetModuleHandleA(lpModuleName);
    }
  }
  /*
  BOOL CreateProcessA(LPCSTR lpApplicationName, LPSTR lpCommandLine,
      LPSECURITY_ATTRIBUTES lpProcessAttributes, LPSECURITY_ATTRIBUTES lpThreadAttributes,
      BOOL bInheritHandles, DWORD dwCreationFlags, LPVOID lpEnvironment, LPCSTR lpCurrentDirectory,
      LPSTARTUPINFOA lpStartupInfo, LPPROCESS_INFORMATION lpProcessInformation);
  BOOL CreateProcessW(LPCWSTR lpApplicationName, LPWSTR lpCommandLine,
      LPSECURITY_ATTRIBUTES lpProcessAttributes, LPSECURITY_ATTRIBUTES lpThreadAttributes,
      BOOL bInheritHandles, DWORD dwCreationFlags, LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory,
      LPSTARTUPINFOW lpStartupInfo, LPPROCESS_INFORMATION lpProcessInformation);
  version(unicode)
  {
    BOOL CreateProcess(LPCWSTR lpApplicationName, LPWSTR lpCommandLine,
      LPSECURITY_ATTRIBUTES lpProcessAttributes, LPSECURITY_ATTRIBUTES lpThreadAttributes,
      BOOL bInheritHandles, DWORD dwCreationFlags, LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory,
      LPSTARTUPINFOW lpStartupInfo, LPPROCESS_INFORMATION lpProcessInformation)
    {
      return CreateProcessW(lpApplicationName, lpCommandLine, lpProcessAttributes, lpThreadAttributes,
        bInheritHandles, dwCreationFlags, lpEnvironment, lpCurrentDirectory, lpStartupInfo, lpProcessInformation);
    }
  }
  else
  {
    BOOL CreateProcess(LPCSTR lpApplicationName, LPSTR lpCommandLine,
      LPSECURITY_ATTRIBUTES lpProcessAttributes, LPSECURITY_ATTRIBUTES lpThreadAttributes,
      BOOL bInheritHandles, DWORD dwCreationFlags, LPVOID lpEnvironment, LPCSTR lpCurrentDirectory,
      LPSTARTUPINFOA lpStartupInfo, LPPROCESS_INFORMATION lpProcessInformation)
    {
      return CreateProcessA(lpApplicationName, lpCommandLine, lpProcessAttributes, lpThreadAttributes,
        bInheritHandles, dwCreationFlags, lpEnvironment, lpCurrentDirectory, lpStartupInfo, lpProcessInformation);
    }
  }
  */

  void OutputDebugStringA(LPCSTR lpOutputString);
  void OutputDebugStringW(LPCWSTR lpOutputString);
  version(unicode)
  {
    void OutputDebugString(LPCWSTR lpOutputString)
    {
      OutputDebugStringW(lpOutputString);
    }
  }
  else
  {
    void OutputDebugString(LPCSTR lpOutputString)
    {
      OutputDebugStringA(lpOutputString);
    }
  }
}